#include <windows.h>
#include <io.h>
#include <memory.h>
#include <fcntl.h>

#include "type.h"
#include "Win32Def.h"
#include "joydrv.h"

static char *padbuf = NULL;

//-----------------------------------------------------------------

// This Function is called when emulator starts
int JOY_OPEN(UINT32 *joy)
{
// Nothing to do here
 return FPSE_OK;
}

// This Function is called when emulator is closed
void JOY_CLOSE()
{
// Nothing to do here
}

// This function is called when the gamepad should vibrate:
// if (motor != 0) then vibrate(on) else vibrate(off)
void JOY_VIBRATE(int motor)
{
}

// Return status of buttons (see joydrv.h)
void JOY_POLL()
{
    padbuf[3] = 0xFF;
    padbuf[4] = 0xFF;
}

int JOY_INIT(char *buf)
{
    padbuf = buf;
    buf[1] = 0x41;
    buf[2] = 0x5A;
    return 5;
}

#define VERSION     0x0100  // Version must be in BCD format

static FPSEWin32About info = {
#ifdef __PSX_PAD_0__
    FPSE_JOY0,
#else
    FPSE_JOY1,
#endif
    VERSION & 0xFF,
    VERSION >> 8,
    0,
    "LDChen",
    "JOYNull",
    "This Plugin simply emulates digital gamepad.\x00d\x00a"
    "NO DirectX required."
};
static HANDLE hinstance = (HANDLE)-1;

BOOL WINAPI
#ifdef __GNUC__
LibMain
#else
DllMain
#endif
(HANDLE hInstance, DWORD fdwReason, PVOID fImpLoad)
{
    hinstance = hInstance;
    return TRUE;
}


void JOY_ABOUT(UINT32 *par)
{
    memcpy( par, &info, sizeof(FPSEWin32About) );
}

int JOY_CONFIG(UINT32 *par)
{
    FPSEWin32 *info = (FPSEWin32 *)par;

    MessageBox(info->HWnd,"This plugin doesn't require configuration",
               "JoyNULL Config", MB_OK);
    return FPSE_OK;
}
