#include <windows.h>
#include <io.h>
#include <memory.h>
#include <fcntl.h>

#include "type.h"
#include "Win32Def.h"
#include "joydrv.h"

static int keybind[16] = {
	VK_INSERT,	/* L2 */
	VK_PRIOR,	/* R2 */
	VK_DELETE,	/* L1 */
	VK_NEXT,	/* R1 */
	'V',		/* /\ */
	'Z',		/*  O */
	'X',		/*  X */
	'C',		/* [] */
	VK_TAB,		/* SELECT */
	0,
	0,
	VK_RETURN,	/* START */
	VK_UP,		/* UP */
	VK_RIGHT,	/* RIGHT */
	VK_DOWN,	/* DOWN */
	VK_LEFT		/* LEFT */
};

static char *padbuf;

//--------------------------------------------------------------------

// This Function is called when emulator starts
int JOY_OPEN(UINT32 *joy)
{
// Nothing to do here
 return FPSE_OK;
}

// This Function is called when emulator is closed
void JOY_CLOSE()
{
// Nothing to do here
}

// This function is called when the gamepad should vibrate:
// if (motor != 0) then vibrate(on) else vibrate(off)
void JOY_VIBRATE(int motor)
{
}

// Return status of buttons (see joydrv.h)
void JOY_POLL()
{
    int i,ret=0;

    for(i=0;i<16;i++) {
        int keycode = keybind[i];
        if (keycode && GetAsyncKeyState(keycode)<0) ret|=(1<<i);
    }

    ret = ~ret;
    padbuf[3] = ret >> 8;
    padbuf[4] = ret;
}

int JOY_INIT(char *buf)
{
    padbuf = buf;
    buf[1] = 0x41;
    buf[2] = 0x5A;
    return 5;
}

#define VERSION     0x0100  // Version must be in BCD format

static FPSEWin32About info = {
#ifdef __PSX_PAD_0__
    FPSE_JOY0,
#else
    FPSE_JOY1,
#endif
    VERSION & 0xFF,
    VERSION >> 8,
    0,
    "LDChen",
    "JOYWin32",
    "This Plugin emulates digital gamepad on the keyboard.\x00d\x00a"
    "\x00d\x00aUse:\x00d\x00a"
    " Up, Down, Left, Right =  directions\x00d\x00a"
    " V = Triangle\x00d\x00a"
    " Z = Circle\x00d\x00a"
    " C = Square\x00d\x00a"
    " X = Cross\x00d\x00a"
    " ENTER = Start\x00d\x00a"
    " TAB = Select\x00d\x00a"
    " Delete = L1\x00d\x00a"
    " Insert = L2\x00d\x00a"
    " PageUp = R1\x00d\x00a"
    " PageDn = R2\x00d\x00a\x00d\x00a"
    "NO DirectX required."
};
static HANDLE hinstance = (HANDLE)-1;

BOOL WINAPI
#ifdef __GNUC__
LibMain
#else
DllMain
#endif
(HANDLE hInstance, DWORD fdwReason, PVOID fImpLoad)
{
    hinstance = hInstance;
    return TRUE;
}


void JOY_ABOUT(UINT32 *par)
{
    memcpy( par, &info, sizeof(FPSEWin32About) );
}

int JOY_CONFIG(UINT32 *par)
{
    FPSEWin32 *info = (FPSEWin32 *)par;

    MessageBox(info->HWnd,"This plugin doesn't require configuration",
               "JoyW32 Config", MB_OK);
    return FPSE_OK;
}
